Index: lemon/bits/alteration_notifier.h
===================================================================
--- lemon/bits/alteration_notifier.h	(revision 1946)
+++ lemon/bits/alteration_notifier.h	(revision 1956)
@@ -1,7 +1,9 @@
 /* -*- C++ -*-
- * lemon/notifier.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Groin on Combinatorial Optimization, EGRES).
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: lemon/bits/array_map.h
===================================================================
--- lemon/bits/array_map.h	(revision 1946)
+++ lemon/bits/array_map.h	(revision 1956)
@@ -1,7 +1,9 @@
 /* -*- C++ -*-
- * lemon/bits/array_map.h - Part of LEMON, a generic C++ optimization library
- *
- * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Groin on Combinatorial Optimization, EGRES).
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: lemon/bits/clearable_graph_extender.h
===================================================================
--- lemon/bits/clearable_graph_extender.h	(revision 1910)
+++ lemon/bits/clearable_graph_extender.h	(revision 1956)
@@ -1,3 +1,19 @@
-// -*- c++ -*-
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
 
 #ifndef LEMON_CLEARABLE_GRAPH_EXTENDER_H
Index: lemon/bits/default_map.h
===================================================================
--- lemon/bits/default_map.h	(revision 1946)
+++ lemon/bits/default_map.h	(revision 1956)
@@ -1,7 +1,9 @@
 /* -*- C++ -*-
- * lemon/default_map.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Groin on Combinatorial Optimization, EGRES).
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: lemon/bits/erasable_graph_extender.h
===================================================================
--- lemon/bits/erasable_graph_extender.h	(revision 1909)
+++ lemon/bits/erasable_graph_extender.h	(revision 1956)
@@ -1,3 +1,19 @@
-// -*- c++ -*-
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
 
 #ifndef LEMON_ERASABLE_GRAPH_EXTENDER_H
Index: lemon/bits/extendable_graph_extender.h
===================================================================
--- lemon/bits/extendable_graph_extender.h	(revision 1910)
+++ lemon/bits/extendable_graph_extender.h	(revision 1956)
@@ -1,3 +1,19 @@
-// -*- c++ -*-
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
 
 #ifndef LEMON_EXTENDABLE_GRAPH_EXTENDER_H
Index: lemon/bits/graph_extender.h
===================================================================
--- lemon/bits/graph_extender.h	(revision 1910)
+++ lemon/bits/graph_extender.h	(revision 1956)
@@ -1,8 +1,9 @@
 /* -*- C++ -*-
- * lemon/graph_extender.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi
- * Kutatocsoport (Egervary Research Groin on Combinatorial Optimization,
- * EGRES).
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: lemon/bits/item_reader.h
===================================================================
--- lemon/bits/item_reader.h	(revision 1946)
+++ lemon/bits/item_reader.h	(revision 1956)
@@ -1,7 +1,9 @@
 /* -*- C++ -*-
- * lemon/bits/item_reader.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Groin on Combinatorial Optimization, EGRES).
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: lemon/bits/item_writer.h
===================================================================
--- lemon/bits/item_writer.h	(revision 1946)
+++ lemon/bits/item_writer.h	(revision 1956)
@@ -1,7 +1,9 @@
 /* -*- C++ -*-
- * lemon/bits/item_reader.h - Part of LEMON, a generic C++ optimization library
- *
- * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Groin on Combinatorial Optimization, EGRES).
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: lemon/bits/iterable_graph_extender.h
===================================================================
--- lemon/bits/iterable_graph_extender.h	(revision 1934)
+++ lemon/bits/iterable_graph_extender.h	(revision 1956)
@@ -1,3 +1,20 @@
-// -*- c++ -*-
+/* -*- C++ -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
 #ifndef LEMON_ITERABLE_GRAPH_EXTENDER_H
 #define LEMON_ITERABLE_GRAPH_EXTENDER_H
Index: lemon/bits/map_extender.h
===================================================================
--- lemon/bits/map_extender.h	(revision 1910)
+++ lemon/bits/map_extender.h	(revision 1956)
@@ -1,7 +1,9 @@
 /* -*- C++ -*-
- * lemon/map_extender.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Groin on Combinatorial Optimization, EGRES).
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: lemon/bits/static_map.h
===================================================================
--- lemon/bits/static_map.h	(revision 1946)
+++ lemon/bits/static_map.h	(revision 1956)
@@ -1,7 +1,9 @@
 /* -*- C++ -*-
- * lemon/static_map.h - Part of LEMON, a generic C++ optimization library
  *
- * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Groin on Combinatorial Optimization, EGRES).
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted
Index: lemon/bits/vector_map.h
===================================================================
--- lemon/bits/vector_map.h	(revision 1946)
+++ lemon/bits/vector_map.h	(revision 1956)
@@ -1,7 +1,9 @@
 /* -*- C++ -*-
- * lemon/vector_map.h - Part of LEMON, a generic C++ optimization library
- *
- * Copyright (C) 2006 Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Groin on Combinatorial Optimization, EGRES).
+ *
+ * This file is a part of LEMON, a generic C++ optimization library
+ *
+ * Copyright (C) 2003-2006
+ * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
+ * (Egervary Research Group on Combinatorial Optimization, EGRES).
  *
  * Permission to use, modify and distribute this software is granted