Index: doc/groups.dox
===================================================================
--- doc/groups.dox	(revision 1914)
+++ doc/groups.dox	(revision 1996)
@@ -92,10 +92,10 @@
 
 /**
-@defgroup graphmapfactory Tools to Make It Easier to Make Graph Maps
+@defgroup graphbits Tools to Make It Easier to Make Graphs
 @ingroup auxdat
-\brief Tools to Make It Easier to Make Graph Maps.
-
-This group describes the tools that makes it easier to make graph maps that
-dynamically update with the graph changes.
+\brief Tools to Make It Easier to Make Graphs.
+
+This group describes the tools that makes it easier to make graphs and
+the maps that dynamically update with the graph changes.
 */
 
Index: lemon/bits/alteration_notifier.h
===================================================================
--- lemon/bits/alteration_notifier.h	(revision 1989)
+++ lemon/bits/alteration_notifier.h	(revision 1996)
@@ -23,5 +23,5 @@
 #include <algorithm>
 
-///\ingroup graphmapfactory
+///\ingroup graphbits
 ///\file
 ///\brief Observer registry for graph alteration observers.
@@ -29,5 +29,5 @@
 namespace lemon {
 
-  /// \addtogroup graphmapfactory
+  /// \addtogroup graphbits
   /// @{
 
Index: lemon/bits/array_map.h
===================================================================
--- lemon/bits/array_map.h	(revision 1956)
+++ lemon/bits/array_map.h	(revision 1996)
@@ -17,6 +17,6 @@
  */
 
-#ifndef LEMON_ARRAY_MAP_H
-#define LEMON_ARRAY_MAP_H
+#ifndef LEMON_BITS_ARRAY_MAP_H
+#define LEMON_BITS_ARRAY_MAP_H
 
 #include <memory>
@@ -26,5 +26,5 @@
 #include <lemon/concept/maps.h>
 
-/// \ingroup graphmapfactory
+/// \ingroup graphbits
 /// \file
 /// \brief Graph maps that construct and destruct
@@ -33,5 +33,5 @@
 namespace lemon {
 
-  /// \ingroup graphmapfactory
+  /// \ingroup graphbits
   ///
   /// \brief Graph map based on the array storage.
@@ -305,3 +305,3 @@
 }
 
-#endif //LEMON_ARRAY_MAP_H
+#endif 
Index: lemon/bits/default_map.h
===================================================================
--- lemon/bits/default_map.h	(revision 1979)
+++ lemon/bits/default_map.h	(revision 1996)
@@ -25,5 +25,5 @@
 #include <lemon/bits/static_map.h>
 
-///\ingroup graphmapfactory
+///\ingroup graphbits
 ///\file
 ///\brief Graph maps that construct and destruct
Index: lemon/bits/edge_set_extender.h
===================================================================
--- lemon/bits/edge_set_extender.h	(revision 1991)
+++ lemon/bits/edge_set_extender.h	(revision 1996)
@@ -17,7 +17,20 @@
  */
 
-
+#ifndef LEMON_BITS_EDGE_SET_EXTENDER_H
+#define LEMON_BITS_EDGE_SET_EXTENDER_H
+
+#include <lemon/bits/invalid.h>
+#include <lemon/error.h>
+
+#include <lemon/bits/default_map.h>
+
+///\ingroup graphbits
+///\file
+///\brief Extenders for the edge set types
 namespace lemon {
 
+  /// \ingroup graphbits
+  ///
+  /// \brief Extender for the EdgeSets
   template <typename Base>
   class EdgeSetExtender : public Base {
@@ -260,4 +273,7 @@
 
 
+  /// \ingroup graphbits
+  ///
+  /// \brief Extender for the UEdgeSets
   template <typename Base>
   class UEdgeSetExtender : public Base {
@@ -608,3 +624,6 @@
     
   };
+
 }
+
+#endif
Index: lemon/bits/graph_adaptor_extender.h
===================================================================
--- lemon/bits/graph_adaptor_extender.h	(revision 1979)
+++ lemon/bits/graph_adaptor_extender.h	(revision 1996)
@@ -17,10 +17,21 @@
  */
 
-#ifndef LEMON_GRAPH_ADAPTOR_EXTENDER_H
-#define LEMON_GRAPH_ADAPTOR_EXTENDER_H
-
-
+#ifndef LEMON_BITS_GRAPH_ADAPTOR_EXTENDER_H
+#define LEMON_BITS_GRAPH_ADAPTOR_EXTENDER_H
+
+#include <lemon/bits/invalid.h>
+#include <lemon/error.h>
+
+#include <lemon/bits/default_map.h>
+
+
+///\ingroup graphbits
+///\file
+///\brief Extenders for the graph adaptor types
 namespace lemon {
 
+  /// \ingroup graphbits
+  ///
+  /// \brief Extender for the GraphAdaptors
   template <typename Base>
   class GraphAdaptorExtender : public Base {
@@ -184,4 +195,7 @@
 
 
+  /// \ingroup graphbits
+  ///
+  /// \brief Extender for the UGraphAdaptors
   template <typename Base> 
   class UGraphAdaptorExtender : public Base {
Index: lemon/bits/graph_extender.h
===================================================================
--- lemon/bits/graph_extender.h	(revision 1993)
+++ lemon/bits/graph_extender.h	(revision 1996)
@@ -17,6 +17,6 @@
  */
 
-#ifndef LEMON_GRAPH_EXTENDER_H
-#define LEMON_GRAPH_EXTENDER_H
+#ifndef LEMON_BITS_GRAPH_EXTENDER_H
+#define LEMON_BITS_GRAPH_EXTENDER_H
 
 #include <lemon/bits/invalid.h>
@@ -25,6 +25,12 @@
 #include <lemon/bits/default_map.h>
 
+///\ingroup graphbits
+///\file
+///\brief Extenders for the graph types
 namespace lemon {
 
+  /// \ingroup graphbits
+  ///
+  /// \brief Extender for the Graphs
   template <typename Base>
   class GraphExtender : public Base {
@@ -321,4 +327,7 @@
   };
 
+  /// \ingroup graphbits
+  ///
+  /// \brief BaseExtender for the UGraphs
   template <typename Base>
   class UGraphBaseExtender : public Base {
@@ -561,4 +570,7 @@
 
 
+  /// \ingroup graphbits
+  ///
+  /// \brief Extender for the UGraphs
   template <typename Base> 
   class UGraphExtender : public Base {
@@ -979,4 +991,7 @@
 
 
+  /// \ingroup graphbits
+  ///
+  /// \brief BaseExtender for the BpUGraphs
   template <typename Base>
   class BpUGraphBaseExtender : public Base {
@@ -1168,4 +1183,7 @@
   };
 
+  /// \ingroup graphbits
+  ///
+  /// \brief Extender for the BpUGraphs
   template <typename Base>
   class BpUGraphExtender : public Base {
@@ -1797,3 +1815,3 @@
 }
 
-#endif // LEMON_UNDIR_GRAPH_EXTENDER_H
+#endif
Index: lemon/bits/map_extender.h
===================================================================
--- lemon/bits/map_extender.h	(revision 1993)
+++ lemon/bits/map_extender.h	(revision 1996)
@@ -29,4 +29,5 @@
 namespace lemon {
 
+  /// \ingroup graphbits
   template <typename _Map>
   class IterableMapExtender : public _Map {
Index: lemon/bits/traits.h
===================================================================
--- lemon/bits/traits.h	(revision 1993)
+++ lemon/bits/traits.h	(revision 1996)
@@ -298,3 +298,3 @@
 }
 
-#endif // LEMON_MAPS_H
+#endif
Index: lemon/bits/vector_map.h
===================================================================
--- lemon/bits/vector_map.h	(revision 1993)
+++ lemon/bits/vector_map.h	(revision 1996)
@@ -29,5 +29,5 @@
 #include <lemon/concept/maps.h>
 
-/// \ingroup graphmapfactory
+/// \ingroup graphbits
 ///
 ///\file
@@ -36,5 +36,5 @@
 namespace lemon {
 
-  /// \ingroup graphmapfactory
+  /// \ingroup graphbits
   ///
   /// \brief Graph map based on the std::vector storage.