Index: doc/groups.dox
===================================================================
--- doc/groups.dox	(revision 1996)
+++ doc/groups.dox	(revision 2006)
@@ -26,9 +26,9 @@
 operations, these together satisfy the everyday requirements. 
 In the case of graph strutures, different operations are needed which do 
-not alter the physical graph, but gives an other view. If some nodes or 
+not alter the physical graph, but gives another view. If some nodes or 
 edges have to be hidden or the reverse oriented graph have to be used, then 
 this is the case. It also may happen that in a flow implemenation 
-the residual graph can be accessed by an other algorithm, or a node-set 
-is to be shrunk for an other algorithm. 
+the residual graph can be accessed by another algorithm, or a node-set 
+is to be shrunk for another algorithm. 
 LEMON also provides a variety of graphs for these requirements called 
 \ref graph_adaptors "graph adaptors". Adaptors cannot be used alone but only 
Index: lemon/bits/alteration_notifier.h
===================================================================
--- lemon/bits/alteration_notifier.h	(revision 1999)
+++ lemon/bits/alteration_notifier.h	(revision 2006)
@@ -45,5 +45,5 @@
   /// edges. If we want to check on every indicing if the map contains
   /// the current indicing key that cause a drawback in the performance
-  /// in the library. We use an other solution we notify all maps about
+  /// in the library. We use another solution we notify all maps about
   /// an alteration in the graph, which cause only drawback on the
   /// alteration of the graph.
Index: lemon/graph_utils.h
===================================================================
--- lemon/graph_utils.h	(revision 2002)
+++ lemon/graph_utils.h	(revision 2006)
@@ -457,5 +457,5 @@
   /// \brief Class to copy a graph.
   ///
-  /// Class to copy a graph to an other graph (duplicate a graph). The
+  /// Class to copy a graph to another graph (duplicate a graph). The
   /// simplest way of using it is through the \c copyGraph() function.
   template <typename Target, typename Source>
@@ -580,7 +580,7 @@
   };
 
-  /// \brief Copy a graph to an other graph.
-  ///
-  /// Copy a graph to an other graph.
+  /// \brief Copy a graph to another graph.
+  ///
+  /// Copy a graph to another graph.
   /// The usage of the function:
   /// 
@@ -600,5 +600,5 @@
   /// \brief Class to copy an undirected graph.
   ///
-  /// Class to copy an undirected graph to an other graph (duplicate a graph).
+  /// Class to copy an undirected graph to another graph (duplicate a graph).
   /// The simplest way of using it is through the \c copyUGraph() function.
   template <typename Target, typename Source>
@@ -792,7 +792,7 @@
   };
 
-  /// \brief Copy a graph to an other graph.
-  ///
-  /// Copy a graph to an other graph.
+  /// \brief Copy a graph to another graph.
+  ///
+  /// Copy a graph to another graph.
   /// The usage of the function:
   /// 
Index: lemon/sub_graph.h
===================================================================
--- lemon/sub_graph.h	(revision 1990)
+++ lemon/sub_graph.h	(revision 2006)
@@ -374,7 +374,7 @@
   /// \ingroup semi_adaptors
   ///
-  /// \brief Graph which uses a subset of an other graph's nodes and edges.
+  /// \brief Graph which uses a subset of another graph's nodes and edges.
   ///
-  /// Graph which uses a subset of an other graph's nodes and edges. This class
+  /// Graph which uses a subset of another graph's nodes and edges. This class
   /// is an alternative to the SubGraphAdaptor which is created for the
   /// same reason. The main difference between the two class that it
@@ -671,7 +671,7 @@
   /// \ingroup semi_adaptors
   ///
-  /// \brief Graph which uses a subset of an other graph's edges.
+  /// \brief Graph which uses a subset of another graph's edges.
   ///
-  /// Graph which uses a subset of an other graph's edges. This class
+  /// Graph which uses a subset of another graph's edges. This class
   /// is an alternative to the EdgeSubGraphAdaptor which is created for the
   /// same reason. The main difference between the two class that it
Index: lemon/unionfind.h
===================================================================
--- lemon/unionfind.h	(revision 2004)
+++ lemon/unionfind.h	(revision 2006)
@@ -430,5 +430,5 @@
 
     /**
-     * \brief Moves the given element to an other component.
+     * \brief Moves the given element to another component.
      *
      * This method moves the element \e a from its component
Index: lemon/xy.h
===================================================================
--- lemon/xy.h	(revision 1999)
+++ lemon/xy.h	(revision 2006)
@@ -401,5 +401,5 @@
 //       }
 
-      ///Increments a bounding box with an other bounding box
+      ///Increments a bounding box with another bounding box
       BoundingBox& add(const BoundingBox &u){
         if ( !u.empty() ){
Index: test/xy_test.cc
===================================================================
--- test/xy_test.cc	(revision 1956)
+++ test/xy_test.cc	(revision 2006)
@@ -79,4 +79,4 @@
 	doboz2.add(doboz1);
 	check(doboz2.inside(seged),
-	      "It should be inside. Incremented a box with an other.");
+	      "It should be inside. Incremented a box with another one.");
 }